Loading...
Searching...
No Matches
Qore::ObjectIterator Class Reference

This class a basic iterator class for objects. More...

`#include <QC_ObjectIterator.dox.h>`

Inheritance diagram for Qore::ObjectIterator:
[legend]

## Public Member Functions

| constructor (object o)
| Creates the object iterator object. More...
| constructor ()
| Creates an empty object iterator object. More...
| copy ()
| Creates a copy of the ObjectIterator object, iterating the same object as the original and in the same position. More...
Public Member Functions inherited from Qore::HashIterator
| constructor (hash< auto > h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the hash is empty; False if not More...
bool | first ()
| returns True if on the first element of the hash More...
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
auto | getKeyValue ()
| returns the current value of the current hash key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
auto | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash< auto > | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
bool | last ()
| returns True if on the last element of the hash More...
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty. More...
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty. More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...
abstract bool | prev ()
| Moves the current position to the previous element; returns False if there are no more elements. More...
abstract auto | getValue ()
| returns the current value More...
abstract bool | next ()
| Moves the current position to the next element; returns False if there are no more elements. More...
abstract bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...
abstract bool | empty ()
| returns True if the object to iterate is empty; False if not More...
abstract bool | first ()
| returns True if on the first element More...
abstract bool | last ()
| returns True if on the last element More...

## Detailed Description

This class a basic iterator class for objects.

Call ObjectIterator::next() to iterate through the object; do not use the iterator if ObjectIterator::next() returns False. An object can be iterated in reverse order by calling ObjectIterator::prev() instead of ObjectIterator::next()

Example: ObjectIterator basic usage
  class Class1 {
  public {
  int attr1;
  date attr2;
  }
  constructor() {
  attr1 = 1;
  attr2 = now();
  }
  }
  Class1 o();
  ObjectIterator it(o);
  while (it.next()) {
  printf("iter: %n\n", it.getValue());
  }
  iter: 1
  iter: 2013-04-17 16:27:28 Wed +02:00 (CEST)

Note
  - In general, the ObjectIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.

See also
  ObjectReverseIterator

## Member Function Documentation

## constructor() [1/2]

Qore::ObjectIterator::constructor | ( |  | ) |

Creates an empty object iterator object.

Example:
  *object obj = get_object_or_nothing();
  ObjectIterator i(obj);

## constructor() [2/2]

Qore::ObjectIterator::constructor | ( | object | o | ) |

Creates the object iterator object.

Parameters

  o | the object to iterate

Example:
  ObjectIterator i(obj);

## copy()

Qore::ObjectIterator::copy | ( |  | ) |

Creates a copy of the ObjectIterator object, iterating the same object as the original and in the same position.

Example:
  ObjectIterator ni = i.copy();